## grass 8.3.2

=== Makefile ===
#############################################################################
#
# MODULE:   	GRASS Compilation
# AUTHOR(S):	Original author unknown - probably CERL
#   	    	Justin Hickey - Thailand - jhickey AT hpcc.nectec.or.th
#   	    	Markus Neteler - Germany - neteler AT itc.it
#   	    	Andreas Lange - Germany - Andreas.Lange AT Rhein-Main.de
#   	    	Radim Blazek - Italy - blazek AT itc.it
# PURPOSE:  	It provides the commands necessary to compile, install,
#   	    	clean, and uninstall GRASS
#   	    	See INSTALL.md file for usage.
# COPYRIGHT:    (C) 2002-2024 by the GRASS Development Team
#
#               This program is free software under the GNU General Public
#   	    	License (>=v2). Read the file COPYING that comes with GRASS
#   	    	for details.
#
#############################################################################

MODULE_TOPDIR = .

include $(MODULE_TOPDIR)/include/Make/Dir.make
include $(MODULE_TOPDIR)/include/Make/Compile.make

DATE := $(shell date '+%d_%m_%Y')

DIRS = \
	demolocation \
	utils \
	include \
	lib \
	python \
	db \
	display \
	general \
	raster \
	raster3d \
	vector \
	misc \
	imagery \
	ps \
	scripts \
	temporal \
	doc \
	gui \
	visualization \
	locale \
	man \
	macosx \
	mswindows

SUBDIRS = $(DIRS)

FILES = AUTHORS CHANGES CITING COPYING GPL.TXT INSTALL.md REQUIREMENTS.md contributors.csv contributors_extra.csv translators.csv
FILES_DST = $(patsubst %,$(ARCH_DISTDIR)/%,$(FILES))

default:
	@echo "GRASS GIS $(GRASS_VERSION_MAJOR).$(GRASS_VERSION_MINOR).$(GRASS_VERSION_RELEASE) $(GRASS_VERSION_GIT) compilation log" \
		> $(ERRORLOG)
	@echo "--------------------------------------------------" >> $(ERRORLOG)
	@echo "Started compilation: `date`"                        >> $(ERRORLOG)
	@echo "--"                                                 >> $(ERRORLOG)
	@echo "Errors in:"                                         >> $(ERRORLOG)
	-$(CHMOD) 755 install-sh
	$(MAKE) subdirs
	$(MAKE) $(FILES_DST)
	$(MAKE) manifests
	@if [ `wc -l < "$(ERRORLOG)"` -gt 5 ] ; then \
		echo "--"     >> $(ERRORLOG) ; \
		echo "In case of errors please change into the directory with error and run 'make'." >> $(ERRORLOG) ; \
		echo "If you get multiple errors, you need to deal with them in the order they"      >> $(ERRORLOG) ; \
		echo "appear in the error log. If you get an error building a library, you will"     >> $(ERRORLOG) ; \
		echo "also get errors from anything which uses the library."  >> $(ERRORLOG) ; \
	else \
		echo "No errors detected." >> $(ERRORLOG) ; \
	fi
	@echo "--"  >> $(ERRORLOG)
	@echo "Finished compilation: `date`" >> $(ERRORLOG)
	@cat $(ERRORLOG)
	@if [ `wc -l < "$(ERRORLOG)"` -gt 8 ] ; then false ; else true ; fi

manifests:
ifeq ($(MANIFEST),external)
	find $(ARCH_DISTDIR) -type f -name '*.exe' | \
	while read file ; do \
	    $(MAKE) "$$file".manifest ; \
	done
endif

$(ARCH_DISTDIR)/%: %
	$(INSTALL_DATA) $< $@

LIBDIRS = \
	lib/external/shapelib \
	lib/datetime \
	lib/gis \
	lib/linkm \
	lib/db \
	lib/vector \
	db/drivers \
	python

# Compile libraries only
libs:
	$(MAKE) -C include
	$(MAKE) subdirs SUBDIRS=$(LIBDIRS)
	$(MAKE) $(FILES_DST)

cleandistdirs:
	-rm -rf $(ARCH_DISTDIR)
	-rm -rf $(ARCH_BINDIR)

# Clean out the strings extracted from scripts for translation
cleanscriptstrings:
	rm -f locale/scriptstrings/*.c 2>/dev/null

clean: cleandistdirs cleanscriptstrings cleandocs

libsclean: cleandistdirs
	$(MAKE) clean-recursive SUBDIRS=$(LIBDIRS)

distclean: clean
	-rm -f config.cache config.log config.status config.status.$(ARCH) 2>/dev/null
	-rm -f ChangeLog ChangeLog.bak $(ERRORLOG) grass.pc
	-rm -f include/grass/config.h include/grass/version.h
	-rm -f include/Make/Platform.make include/Make/Doxyfile_arch_html include/Make/Doxyfile_arch_latex 2>/dev/null

include $(MODULE_TOPDIR)/include/Make/Install.make
include $(MODULE_TOPDIR)/include/Make/Docs.make
include $(MODULE_TOPDIR)/include/Make/Doxygen.make
include $(MODULE_TOPDIR)/include/Make/Sphinx.make

DOXNAME=grass

.PHONY: default libs
.PHONY: cleandistdirs cleanscriptstrings clean libsclean distclean

=== gui/Makefile ===
MODULE_TOPDIR = ..

SUBDIRS = icons images scripts xml wxpython

include $(MODULE_TOPDIR)/include/Make/Dir.make

default: parsubdirs

=== imagery/Makefile ===
MODULE_TOPDIR = ..

SUBDIRS = \
	i.albedo \
	i.aster.toar \
	i.atcorr \
	i.biomass \
	i.cca \
	i.cluster \
	i.eb.evapfr \
	i.eb.eta \
	i.eb.hsebal01 \
	i.eb.netrad \
	i.eb.soilheatflux \
	i.evapo.mh \
	i.evapo.pm \
	i.evapo.pt \
	i.evapo.time \
	i.emissivity \
	i.find \
	i.gensig \
	i.gensigset \
	i.group \
	i.his.rgb \
	i.landsat.toar \
	i.landsat.acca \
	i.maxlik \
	i.modis.qc \
	i.ortho.photo \
	i.rectify \
	i.rgb.his \
	i.segment \
	i.smap \
	i.target \
	i.topo.corr \
	i.pca \
	i.vi \
	i.fft \
	i.ifft \
	i.zc

PGM = imageryintro

include $(MODULE_TOPDIR)/include/Make/Dir.make

default: htmldir

htmldir: parsubdirs

=== locale/Makefile ===
# written by Markus Neteler
# tcl stuff by Cedric Shock
# wxpython by Martin Landa

MODULE_TOPDIR = ..
include $(MODULE_TOPDIR)/include/Make/Other.make

default:
	@if [ "$(HAVE_NLS)" != "" ] ; then \
		echo "Creating translations (= 'make mo')" >&2 ; \
		$(MAKE) mo ; \
		echo "Creating translation statistics (= 'make statistics')" >&2 ; \
		$(MAKE) statistics ; \
	else \
		echo "NLS disabled." ; \
	fi

all:
	@echo 'Usage:'
	@echo '   make pot        create grass.pot (containing original messages)'
	@echo '   make update-po  merge new messages into existing *.po files'
	@echo '   make mo         create the *.mo files'
	@echo '   make verify     verify the *.po files'

# Directory for installing tcl .msg files:
PO_DIR = po

#distinguish between library messages and modules:
LIBDOMAIN = grasslibs
MODDOMAIN = grassmods
WXPYDOMAIN = grasswxpy
DOMAINS = $(LIBDOMAIN) $(MODDOMAIN) $(WXPYDOMAIN)

LIB_POTFILES = find ../lib \( -name "*.c" -o -name "*.py" \) | xargs grep -l "_(\"\|n_(\""
MOD_POTFILES = find ../ \( -name "*.c" -o -name "*.cpp" \) | grep -v '../lib' | xargs grep -l "_(\"\|n_(\""
WXPY_POTFILES = find ../gui/wxpython -name '*.py' | xargs grep -l "_(\"\|n_(\""
#For Python script module messages
MOD_PYFILES = find ../scripts -name '*.py' | xargs grep -l "_(\"\|n_(\""

define po_stats
GISBASE="$(RUN_GISBASE)" $(PYTHON) ./grass_po_stats.py
endef

#The xgettext utility is used to automate the creation of
#portable message files (.po)
pot:
	if [ ! -f ../gui/wxpython/menustrings.py ] ; then \
		echo "Build GRASS before running 'make pot'" >&2 ; \
		exit 1 ; \
	fi
	@rm -f ./templates/*.pot
	@echo "Generating $(LIBDOMAIN)..."
	xgettext --from-code=utf-8 --keyword=_ --keyword=n_:1,2 -cGTC -o ./templates/$(LIBDOMAIN).pot `$(LIB_POTFILES)`
	@echo "Generating $(MODDOMAIN)..."
	xgettext --from-code=utf-8 --keyword=_ --keyword=n_:1,2 -cGTC -o ./templates/$(MODDOMAIN).pot `$(MOD_POTFILES)`
	xgettext --from-code=utf-8 -j --keyword=_ --keyword=n_:1,2 -cGTC -o ./templates/$(MODDOMAIN).pot `$(MOD_PYFILES)`
	@echo "Generating $(WXPYDOMAIN)..."
	xgettext --from-code=utf-8 --keyword=_ --keyword=n_:1,2 -cGTC -o ./templates/$(WXPYDOMAIN).pot `$(WXPY_POTFILES)`

#merge already existing translations with new messages in POT template file and create new po files:
update-po:
	@for i in $(DOMAINS) ; do \
		if [ "`ls ./po/$$i\_*.po 2>/dev/null`" = "" ] ; then \
		 echo "No $$i.po file found in ./po/ directory. Will create new po files from template." ; \
		 cp ./templates/$$i.pot ./po/$$i.po ; \
		 echo "Created ./po/$$i.po - Rename to ./po/$$i\_LANG.po (with LANG: de, ru, ...)" ; \
		 echo "Then you can translate the messages in this file (e.g with kbabel)" ; \
		fi ;\
	done
	@cd ./po/ ; for po in `ls *_*.po 2>/dev/null` ; do \
		suffix=`echo $$po | cut -d'_' -f2-`; \
		lingua=`basename $$suffix .po`; \
		prefix=`echo $$po | cut -d'_' -f1`; \
		if msgmerge -o $$prefix\_$$suffix.new $$prefix\_$$suffix ../templates/$$prefix.pot; then\
		  mv $$prefix\_$$suffix.new $$prefix\_$$suffix; \
		  echo "Merged new messages into $$prefix\_$$suffix" ; \
		else \
		    echo "Merging failed"; \
		fi \
		done
	@echo "Be careful with git commits as .po file updates must be synchronized with the individual translators."

verify:
	@cd ./po/ ; for po in `ls *_*.po 2>/dev/null` ; do \
		echo "----- $$po:" ; \
		msgfmt -c $$po; \
	done
	@rm -f po/messages.mo
	@echo "Note: In case of translations errors to be fixed, edit the respective translation on transifex (and not in git)"

statistics:
	$(call po_stats)

define dom_rule
$(1)_FILES := $$(patsubst po/grass$(1)_%.po,$$(MO_DIR)/%/LC_MESSAGES/grass$(1).mo,$$(wildcard po/grass$(1)_*.po))
$$(MO_DIR)/%/LC_MESSAGES/grass$(1).mo: po/grass$(1)_%.po
	@ [ -d $$(MO_DIR)/$$*/LC_MESSAGES ] || $(MKDIR) $$(MO_DIR)/$$*/LC_MESSAGES
	msgfmt --statistics -o $$@ $$<
endef
$(foreach domain,libs mods wxpy,$(eval $(call dom_rule,$(domain))))

$(MSG_DIR)/%.msg: po/grasstcl_%.po
	@ [ -d $(MSG_DIR) ] || $(MKDIR) $(MSG_DIR)
	msgfmt --statistics --tcl -l $* -d $(MSG_DIR)/ $<

MSGFILES := $(patsubst po/grasstcl_%.po,$(MSG_DIR)/%.msg,$(wildcard po/grasstcl_*.po))

#create binary messages files
mo: $(libs_FILES) $(mods_FILES) $(wxpy_FILES) $(MSGFILES)

.PHONY: mo

=== mswindows/Makefile ===
MODULE_TOPDIR = ..

SUBDIRS = \
	osgeo4w

include $(MODULE_TOPDIR)/include/Make/Dir.make

EXTRA_CLEAN_FILES = GRASS-Packager.bat GRASS-Installer.nsi

ifneq ($(MINGW),)
default: GRASS-Packager.bat GRASS-Installer.nsi parsubdirs
else
default:
endif	

GRASS-Packager.bat: GRASS-Packager.bat.tmpl
	sed \
	-e 's#@GRASS_VERSION_MAJOR@#$(GRASS_VERSION_MAJOR)#' \
	-e 's#@GRASS_VERSION_MINOR@#$(GRASS_VERSION_MINOR)#' \
	$< > $@

GRASS-Installer.nsi: GRASS-Installer.nsi.tmpl
	sed \
	-e 's#@GRASS_VERSION_GIT@#$(GRASS_VERSION_GIT)#' \
	-e 's#@GRASS_VERSION_MAJOR@#$(GRASS_VERSION_MAJOR)#' \
	-e 's#@GRASS_VERSION_MINOR@#$(GRASS_VERSION_MINOR)#' \
	-e 's#@GRASS_VERSION_RELEASE@#$(GRASS_VERSION_RELEASE)#' \
	-e 's#@ARCH@#$(ARCH)#' \
	$< > $@

=== ps/Makefile ===

MODULE_TOPDIR = ..

SUBDIRS = \
	ps.map

include $(MODULE_TOPDIR)/include/Make/Dir.make

default: parsubdirs

=== scripts/Makefile ===
MODULE_TOPDIR = ..

SUBDIRS = \
	d.background \
	d.correlate \
	d.frame \
	d.out.file \
	d.to.rast \
	d.polar \
	d.rast.edit \
	d.rast.leg \
	d.redraw \
	d.shade \
	d.what.rast \
	d.what.vect \
	db.dropcolumn \
	db.droptable \
	db.in.ogr \
	db.out.ogr \
	db.test \
	db.univar \
	g.download.location \
	g.extension \
	g.extension.all \
	g.manual \
	g.search.modules \
	i.band.library \
	i.colors.enhance \
	i.image.mosaic \
	i.in.spotvgt \
	i.oif \
	i.pansharpen \
	i.spectral \
	i.tasscap \
	m.proj \
	r.blend \
	r.buffer.lowmem \
	r.colors.stddev \
	r.drain \
	r.fillnulls \
	r.grow \
	r.import \
	r.in.aster \
	r.in.srtm \
	r.in.wms \
	r.mapcalc.simple \
	r.mask \
	r.out.xyz \
	r.pack \
	r.plane \
	r.reclass.area \
	r.rgb \
	r.semantic.label \
	r.shade \
	r.tileset \
	r.unpack \
	r3.in.xyz \
	v.build.all \
	v.centroids \
	v.clip \
	v.db.addcolumn \
	v.db.addtable \
	v.db.join \
	v.db.dropcolumn \
	v.db.droprow \
	v.db.droptable \
	v.db.renamecolumn \
	v.db.reconnect.all \
	v.db.univar \
	v.db.update \
	v.dissolve \
	v.import \
	v.in.e00 \
	v.in.geonames \
	v.in.lines \
	v.in.mapgen \
	v.in.wfs \
	v.rast.stats \
	v.report \
	v.pack \
	v.to.lines \
	v.unpack \
	v.what.strds \
	v.what.vect \
	wxpyimgview

include $(MODULE_TOPDIR)/include/Make/Dir.make

default: parsubdirs

=== testsuite/Makefile ===
MODULE_TOPDIR = ..

SUBDIRS = \
	raster

include $(MODULE_TOPDIR)/include/Make/Dir.make

default: parsubdirs

=== vector/Makefile ===

MODULE_TOPDIR = ..

PGM = vectorintro

SUBDIRS = \
	v.buffer \
	v.build \
	v.build.polylines \
	v.category \
	v.class \
	v.clean \
	v.cluster \
	v.colors \
	v.colors.out \
	v.db.connect \
	v.db.select \
	v.decimate \
	v.delaunay \
	v.distance \
	v.drape \
	v.edit \
	v.extract \
	v.extrude \
	v.generalize \
	v.hull \
	v.info \
	v.in.ascii \
	v.in.db \
	v.in.dxf \
	v.in.pdal \
	v.in.region \
	v.kcv \
	v.kernel \
	v.label \
	v.label.sa \
	v.lidar.correction \
	v.lidar.edgedetection \
	v.lidar.growing \
	v.lrs \
	v.proj \
	v.mkgrid \
	v.neighbors \
	v.net \
	v.net.alloc \
	v.net.allpairs \
	v.net.bridge \
	v.net.centrality \
	v.net.components \
	v.net.connectivity \
	v.net.distance \
	v.net.flow \
	v.net.iso \
	v.net.path \
	v.net.salesman \
	v.net.spanningtree \
	v.net.steiner \
	v.net.timetable \
	v.net.visibility \
	v.normal \
	v.out.ascii \
	v.out.dxf \
	v.out.lidar \
	v.out.postgis \
	v.out.pov \
	v.out.svg \
	v.out.vtk \
	v.outlier \
	v.overlay \
	v.parallel \
	v.patch \
	v.perturb \
	v.split \
	v.qcount \
	v.profile \
	v.random \
	v.reclass \
	v.rectify \
	v.sample \
	v.segment \
	v.select \
	v.support \
	v.surf.bspline \
	v.surf.idw \
	v.surf.rst \
	v.transform \
	v.timestamp \
	v.to.3d \
	v.to.db \
	v.to.points \
	v.to.rast \
	v.to.rast3 \
	v.type \
	v.univar \
	v.voronoi \
	v.what \
	v.what.rast \
	v.what.rast3 \
	v.vect.stats \
	v.vol.rst \
	v.out.ogr \
	v.in.ogr \
	v.external \
	v.in.dwg \
	v.in.lidar \
	v.external.out

include $(MODULE_TOPDIR)/include/Make/Dir.make

default: htmldir

htmldir: parsubdirs

=== db/db.dropdb/Makefile ===

MODULE_TOPDIR = ../..

LIBES = $(DBMILIB) $(GISLIB)
DEPENDENCIES = $(DBMIDEP) $(GISDEP)

PGM = db.dropdb

include $(MODULE_TOPDIR)/include/Make/Module.make

default: cmd

=== display/d.graph/Makefile ===
MODULE_TOPDIR = ../..

PGM = d.graph

LIBES = $(DISPLAYLIB) $(SYMBLIB) $(GISLIB)
DEPENDENCIES = $(DISPLAYDEP) $(SYMBDEP) $(GISDEP)

include $(MODULE_TOPDIR)/include/Make/Module.make

default: cmd $(HTMLDIR)/grass_logo.txt

$(HTMLDIR)/%.txt: %.txt
	$(INSTALL_DATA) $< $@

=== display/d.his/Makefile ===
MODULE_TOPDIR = ../..

PGM = d.his

LIBES = $(DISPLAYLIB) $(RASTERLIB) $(GISLIB)
DEPENDENCIES = $(DISPLAYDEP) $(RASTERDEP) $(GISDEP)

include $(MODULE_TOPDIR)/include/Make/Module.make

default: cmd

=== debian/changelog ===
grass (8.3.2-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 26 Mar 2024 00:35:47 -0700

grass (8.3.2-1) unstable; urgency=medium

  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 08 Mar 2024 07:46:06 +0100

grass (8.3.2-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 07 Mar 2024 18:18:27 +0100

grass (8.3.2~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Replace pkg-config (build) dependency with pkgconf.
  * Update copyright file.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 21 Feb 2024 05:20:46 +0100

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

VERSION=$(shell echo `head -2 $(CURDIR)/include/VERSION` | sed -e 's/ //')
ABI=$(shell echo `head -3 $(CURDIR)/include/VERSION` | sed -e 's/ //g' -e 's/RC/-/')
GRASS_ABI=grass$(ABI)
BASE_NAME=grass$(VERSION)
PKG_NAME=grass

# TODO: fix these
CFLAGS+=-Wno-error=format-security

CFLAGS+=-Wall

CFLAGS+=-DNDEBUG

TEMPLATES=$(wildcard debian/*.in)

# Use SOURCE_DATE_EPOCH as random seed for reproducible builds
ifdef SOURCE_DATE_EPOCH
	export GRASS_RANDOM_SEED=$(SOURCE_DATE_EPOCH)
endif

versions:
	@echo "Version: $(VERSION)"
	@echo "ABI: $(ABI)"

templates:
	for TEMPLATE in $(TEMPLATES) ; do \
	    sed -e 's/@VERSION@/$(VERSION)/g' -e 's/@ABI@/$(ABI)/g' $$TEMPLATE > `echo $$TEMPLATE | sed 's/.in$$//'` ; \
	done

%:
	dh $@

execute_after_dh_clean:
	$(RM) lib/proj/nad2bin
	$(RM) utils/timer/main.o
	$(RM) raster/r.terraflow/IOStream/lib/src/libiostream.a
	$(RM) debian/$(BASE_NAME).1
	$(RM) debian/grass-gui.image-file-in-usr-lib.list
	$(RM) error.log

	# clean doxygen documentation (programming man)
	$(RM) doxygen_sqlite3.db lib/doxygen_sqlite3.db
	$(RM) -r \
		doxygenhtml \
		html latex \
		rfc/html rfc/latex \
		lib/html lib/latex \
		gui/wxpython/html gui/wxpython/latex
	for LIBRARY in \
		db \
		g3d \
		gis \
		gmath \
		gpde \
		ogsf \
		proj \
		python \
		segment \
		vector \
		vector/dglib ; \
	do \
		$(RM) -r lib/$$LIBRARY/html lib/$$LIBRARY/latex ; \
	done

override_dh_auto_clean:
	[ ! -f $(CURDIR)/include/Make/Platform.make ] || $(MAKE) distclean

override_dh_auto_configure: templates
	dh_auto_configure -- \
                    --prefix=/usr/lib \
                    --enable-largefile \
                    --enable-socket \
                    --enable-shared \
                    --with-blas \
                    --with-bzlib \
                    --with-cairo \
                    --with-cxx \
                    --with-freetype \
                    --with-freetype-includes=/usr/include/freetype2 \
                    --with-gdal \
                    --with-geos \
                    --with-lapack \
                    --with-motif \
                    --with-mysql \
                    --with-mysql-includes="$(shell mysql_config --include | sed -e 's/-I//g')" \
                    --with-netcdf \
                    --with-nls \
                    --with-odbc \
                    --with-openmp \
                    --with-pdal=no \
                    --with-postgres \
                    --with-postgres-includes=$(shell pg_config --includedir) \
                    --with-proj-share=/usr/share/proj \
                    --with-python \
                    --with-readline \
                    --with-sqlite \
                    --with-x \
                    --with-zstd

execute_after_dh_auto_build:
	chmod 755 debian/fixpaths.sh

	# generate the Programmers' manual (in HTML)
	$(MAKE) htmldocs-single

	# Strip build path
	sed -i "s@$(CURDIR)@@g" lib/html/search/*.js

override_dh_auto_install:
	# install grass core into debian/tmp
	dh_auto_install -- \
		INST_DIR=/usr/lib/$(BASE_NAME) \
		UNIX_BIN=/usr/bin

	# fix links
	debian/fixpaths.sh $(CURDIR)/debian/tmp debian/tmp

	# delete python compiled bytecode files (maybe dh_python2 takes care of this for us?)
	find debian/tmp/ -type f -name "*.pyc" -delete
	find debian/tmp/ -type d -name "__pycache__" -delete

	# change section from 1 to .1grass
	for m in debian/tmp/usr/lib/$(BASE_NAME)/docs/man/man1/*.1; do \
		n=`basename $$m .1`; mv $$m debian/tmp/usr/lib/$(BASE_NAME)/docs/man/man1/$$n.1grass; done
	for m in debian/tmp/usr/lib/$(BASE_NAME)/docs/man/man1/*.1grass; do \
		sed -i -e 's/^.TH \(.*\) 1/.TH \1 1grass/' "$$m"; done

	# escape minus signs which are command line options not hyphens
	for m in debian/tmp/usr/lib/$(BASE_NAME)/docs/man/man1/*.1grass; do \
		sed -i -e 's/\([ ([]\)-\([a-z]\)/\1\\-\2/g' \
			-e 's/\([ []\)--\([a-z]\)/\1\\-\\-\2/g' \
			-e 's/\[-\\fB/[\\-\\fB/' \
			-e 's/\[--\\fB/[\\-\\-\\fB/g' \
			-e 's/"\\fB-\([a-zA-Z0-9]\)/"\\fB\\-\1/' \
			-e 's/"\\fB--\([a-zA-Z0-9]\)/"\\fB\\-\\-\1/' \
			-e 's/\\fI-\([a-zA-Z0-9]\)/\\fI\-\1/g' \
			"$$m"; done

	# adjust from build-server build dir to end-user's install dir
	sed -i -e "s+^\(GRASS_HOME[ ]*=\) .*+\1 /usr/lib/$(BASE_NAME)+" \
		-e "s+^\(RUN_GISBASE[ ]*=\) .*+\1 /usr/lib/$(BASE_NAME)+" \
		debian/tmp/usr/lib/$(BASE_NAME)/include/Make/Platform.make

	# install pkg-config file
	mkdir -p debian/$(PKG_NAME)-dev/usr/share/pkgconfig
	install -m 644 grass.pc debian/$(PKG_NAME)-dev/usr/share/pkgconfig/$(BASE_NAME).pc

	# install icons and desktop file
	mkdir -p debian/tmp/usr/share/icons
	mv debian/tmp/usr/lib/$(BASE_NAME)/share/icons/hicolor debian/tmp/usr/share/icons

	mkdir -p debian/tmp/usr/share/applications
	mv debian/tmp/usr/lib/$(BASE_NAME)/share/applications/grass.desktop debian/tmp/usr/share/applications/$(BASE_NAME).desktop

	# install AppStream metadata
	mkdir -p debian/tmp/usr/share/metainfo
	mv debian/tmp/usr/lib/$(BASE_NAME)/share/metainfo/org.osgeo.grass.appdata.xml debian/tmp/usr/share/metainfo/org.osgeo.grass.appdata.xml

	# install grass wrapper scripts
	install -m 755 debian/x-grass debian/tmp/usr/bin/x-grass

	# Remove empty directory
	rmdir debian/tmp/usr/lib/$(BASE_NAME)/gui/wxpython/scripts/

	# Remove files not installed or installed by debhelper
	$(RM) -r debian/tmp/usr/lib/$(BASE_NAME)/AUTHORS \
	         debian/tmp/usr/lib/$(BASE_NAME)/CHANGES \
	         debian/tmp/usr/lib/$(BASE_NAME)/CITING \
	         debian/tmp/usr/lib/$(BASE_NAME)/COPYING \
	         debian/tmp/usr/lib/$(BASE_NAME)/GPL.TXT \
	         debian/tmp/usr/lib/$(BASE_NAME)/INSTALL.md \
	         debian/tmp/usr/lib/$(BASE_NAME)/REQUIREMENTS.md \
	         debian/tmp/usr/lib/$(BASE_NAME)/config.status \
	         debian/tmp/usr/lib/$(BASE_NAME)/contributors.csv \
	         debian/tmp/usr/lib/$(BASE_NAME)/contributors_extra.csv \
	         debian/tmp/usr/lib/$(BASE_NAME)/demolocation/PERMANENT/.tmp/* \
	         debian/tmp/usr/lib/$(BASE_NAME)/translation_status.json \
	         debian/tmp/usr/lib/$(BASE_NAME)/translators.csv

	# Move image files from /usr/lib/$(BASE_NAME) to /usr/share/$(BASE_NAME)
	mkdir -p debian/tmp/usr/share/$(BASE_NAME)/gui
	mv debian/tmp/usr/lib/$(BASE_NAME)/gui/icons/  debian/tmp/usr/share/$(BASE_NAME)/gui/
	mv debian/tmp/usr/lib/$(BASE_NAME)/gui/images/ debian/tmp/usr/share/$(BASE_NAME)/gui/

	find debian/tmp/usr/lib/$(BASE_NAME)/gui/wxpython/ -type f \( -name "*.jpg" -or -name "*.png" \) -print | sort > debian/grass-gui.image-file-in-usr-lib.list

	while read file; do \
		dir=`dirname "$$file" | sed 's/usr\/lib\//usr\/share\//'` ; \
		if [ ! -e "$$dir" ]; then \
			mkdir -p "$$dir" ; \
		fi ; \
		mv "$$file" "$$dir" ; \
	done < debian/grass-gui.image-file-in-usr-lib.list

	# Remove empty files
	find debian/tmp/ -type f -empty -name "class_graphical*" -print -delete

execute_before_dh_install:
	# Strip binaries
	strip --strip-unneeded --remove-section=.comment --remove-section=.note debian/tmp/usr/lib/$(BASE_NAME)/bin/r.in.png
	strip --strip-unneeded --remove-section=.comment --remove-section=.note debian/tmp/usr/lib/$(BASE_NAME)/bin/r.out.png

execute_after_dh_install:
	# delete duplicated grass-gui stuff from grass-core package
	for COMPONENT in gui wxpython; do \
		rm -rf debian/$(PKG_NAME)-core/usr/lib/$(BASE_NAME)/$$COMPONENT; \
	done

override_dh_installchangelogs:
	dh_installchangelogs CHANGES

override_dh_python3:
	dh_python3 -pgrass-core -pgrass-gui -pgrass-dev
	dh_python3 -pgrass-core /usr/lib/$(BASE_NAME)/etc/
	dh_python3 -pgrass-core /usr/lib/$(BASE_NAME)/scripts/
	dh_python3 -pgrass-gui /usr/lib/$(BASE_NAME)/gui/
	dh_python3 -pgrass-dev /usr/lib/$(BASE_NAME)/utils/

override_dh_numpy3:
	dh_numpy3 -pgrass-core -pgrass-gui

override_dh_shlibdeps:
	dh_shlibdeps -l$(CURDIR)/debian/tmp/usr/lib/$(BASE_NAME)/lib

override_dh_compress:

=== debian/watch ===
version=4
opts=\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/;s/RC/rc/;s/_/./g,\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$// \
https://grass.osgeo.org/grass83/source/ \
grass-([\d\._]*(?:(?:RC|rc|pre|dev|beta|alpha)?\d*))\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## grass 8.4.0

=== Makefile ===
--- 
+++ 
@@ -91,6 +91,7 @@
 	$(INSTALL_DATA) $< $@
 
 LIBDIRS = \
+	lib/external/parson \
 	lib/external/shapelib \
 	lib/datetime \
 	lib/gis \

=== scripts/Makefile ===
--- 
+++ 
@@ -9,7 +9,6 @@
 	d.polar \
 	d.rast.edit \
 	d.rast.leg \
-	d.redraw \
 	d.shade \
 	d.what.rast \
 	d.what.vect \

=== debian/changelog ===
grass (8.4.0-1) unstable; urgency=medium

  * Bump Standards-Version to 4.7.0, no changes.
  * Update lintian overrides.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 01 Aug 2024 05:38:31 +0200

grass (8.4.0-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 27 Jul 2024 18:22:27 +0200

grass (8.4.0~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Drop python3-distutils dependency.
    (closes: #1065869)
  * Update watch file for GRASS 8.4 releases.
  * Update copyright file.
  * Refresh patches.
  * Drop obsolete rules.
  * Add patch to fix spelling errors.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 19 Jun 2024 13:33:03 +0200

grass (8.3.2-3) unstable; urgency=medium

  * Add upstream patch to fix FTBFS with GCC 14.
    (closes: #1075041)

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 27 Jul 2024 09:16:02 +0200

grass (8.3.2-2) unstable; urgency=medium

  * Drop python3-distutils dependency.
    (closes: #1065869)

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 17 Jul 2024 10:43:41 +0200

=== debian/control ===
Source: grass
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
           Bas Couwenberg <sebastic@debian.org>
Section: science
Priority: optional
Build-Depends: bison,
               debhelper-compat (= 13),
               dh-python,
               dh-sequence-numpy3,
               dh-sequence-python3,
               doxygen,
               fakeroot,
               flex,
               graphviz,
               libblas-dev,
               libbz2-dev,
               libcairo2-dev,
               libfftw3-dev,
               libfreetype-dev,
               libgdal-dev (>= 2.0),
               libgeos-dev,
               libgl-dev,
               libglu-dev,
               libjpeg-dev,
               liblapack-dev,
               libmotif-dev | lesstif2-dev,
       default-libmysqlclient-dev,
               libncurses-dev,
               libnetcdf-dev,
               libpng-dev,
               libpq-dev,
               libproj-dev,
               libreadline-dev,
               libsqlite3-dev,
               libtiff-dev,
               libxmu-dev,
               libzstd-dev,
               netcdf-bin,
# install optipng if compressing the PNG images in the programmers' manual
#              optipng,
               pkgconf,
# proj-bin needed for nad2bin during config
               proj-bin,
               python3,
               python3-dev,
               python3-numpy,
               python3-pil,
               python3-ply,
               python3-six,
               python3-wxgtk4.0,
               unixodbc-dev,
               zlib1g-dev
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian-gis-team/grass
Vcs-Git: https://salsa.debian.org/debian-gis-team/grass.git
Homepage: https://grass.osgeo.org/
Rules-Requires-Root: no

Package: grass
Architecture: all
Section: metapackages
Depends: grass-core,
         grass-gui,
         ${misc:Depends}
Recommends: grass-doc
Suggests: grass-dev
Description: Geographic Resources Analysis Support System (GRASS GIS)
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 Install this virtual package to get a full GRASS system.

Package: grass-core
Architecture: any
Depends: grass-doc,
         python3-six,
         ${shlibs:Depends},
         ${python3:Depends},
         ${misc:Depends}
Recommends: gdal-bin,
# used by g.extension
            git,
# cs2cs used by m.proj, gdalinfo+gdal_translate used by a number of scripts
            proj-bin
Suggests: grass-dev,
            grass-gui,
# used by v.in.e00
            e00compr,
            avce00,
# used by i.spectral
            gnuplot,
# used by v.in.gpsbabel
            gpsbabel,
# used by v.in.garmin
            gpstrans,
# used by NVIZ, d.out.gpsdrive, r.out.mpeg
            netpbm,
# used by v.kridge
            python3-rpy2,
            python3-termcolor,
# used by g.extension
            subversion
Breaks: grass (<< 6.4.2-1~)
Provides: ${grass:Provides}
Replaces: grass (<< 6.4.2-1~)
Description: GRASS GIS core components
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 This package contains the core processing components, but not the GUI.

Package: grass-gui
Architecture: any
Depends: grass-core,
         python3-wxgtk4.0,
         xterm | x-terminal-emulator,
         ${python3:Depends},
         ${misc:Depends}
Recommends:
# gs needed for wxPsmap PDF export
            ghostscript,
# PIL needed for wxPsmap preview
            python3-matplotlib,
            python3-pil
Breaks: grass (<< 6.4.2-1~)
Replaces: grass (<< 6.4.2-1~)
Description: GRASS GIS graphical user interfaces
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 This package contains the GRASS GUIs.

Package: grass-doc
Section: doc
Architecture: all
Depends: libjs-jquery,
         ${misc:Depends}
Suggests: grass,
          grass-dev-doc
Description: GRASS GIS user documentation
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 This package contains HTML documentation for the GRASS system.

Package: grass-dev-doc
Section: doc
Architecture: all
Depends: libjs-jquery,
         ${misc:Depends}
Suggests: grass
Description: GRASS GIS Programmers' Manual
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 This package contains the HTML version of the GRASS Programmers' Manual.

Package: grass-dev
Section: devel
Architecture: any
Depends: grass-core (= ${binary:Version}),
# fakeroot used by patches/htmlgen-fakeroot; see changelog entry for 5.7.0+6.0.0beta2-2
         fakeroot,
         libfreetype-dev,
         libgdal-dev,
         libpq-dev,
         libproj-dev,
         ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: grass-dev-doc,
          pkgconf
Description: GRASS GIS development files
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 This package contains the header files for developing with GRASS.
 Install this package if you wish to develop software that manipulates
 GRASS data sets or install addons using the g.extension module.

=== debian/rules ===
--- 
+++ 
@@ -167,9 +167,6 @@
 	# install grass wrapper scripts
 	install -m 755 debian/x-grass debian/tmp/usr/bin/x-grass
 
-	# Remove empty directory
-	rmdir debian/tmp/usr/lib/$(BASE_NAME)/gui/wxpython/scripts/
-
 	# Remove files not installed or installed by debhelper
 	$(RM) -r debian/tmp/usr/lib/$(BASE_NAME)/AUTHORS \
 	         debian/tmp/usr/lib/$(BASE_NAME)/CHANGES \
@@ -231,3 +228,8 @@
 	dh_shlibdeps -l$(CURDIR)/debian/tmp/usr/lib/$(BASE_NAME)/lib
 
 override_dh_compress:
+	dh_compress -XAUTHORS
+
+override_dh_fixperms:
+	dh_fixperms -Xr.in.png -Xr.out.png
+

=== debian/watch ===
version=4
opts=\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/;s/RC/rc/;s/_/./g,\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$// \
https://grass.osgeo.org/grass84/source/ \
grass-([\d\._]*(?:(?:RC|rc|pre|dev|beta|alpha)?\d*))\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## grass 8.4.1

=== Makefile ===
MODULE_TOPDIR = ../..

PGM = r.plus.example

include $(MODULE_TOPDIR)/include/Make/Script.make

default: script

=== binder/requirements.txt ===
folium
matplotlib
numpy
Pillow
ply
PyVirtualDisplay

=== db/Makefile ===

MODULE_TOPDIR = ..

SUBDIRS = \
	db.columns \
	db.connect \
	db.copy \
	db.createdb \
	db.databases \
	db.describe \
	db.drivers \
	db.dropdb \
	db.execute \
	db.login \
	db.select \
	db.tables

CLEAN_SUBDIRS = drivers

PGM = databaseintro

include $(MODULE_TOPDIR)/include/Make/Dir.make

default: htmldir

htmldir:
	$(MAKE) -C drivers
	$(MAKE) parsubdirs

=== demolocation/Makefile ===
MODULE_TOPDIR = ..

include $(MODULE_TOPDIR)/include/Make/Other.make

SRCFILES = WIND DEFAULT_WIND VAR PROJ_INFO PROJ_UNITS PROJ_SRID PROJ_EPSG MYNAME
SQLITEMAPS = country_boundaries
MAPFILES = dbln coor topo head cidx sidx hist
SQLITEFILES = sqlite/sqlite.db
VECTFILES := $(foreach map,$(SQLITEMAPS),$(foreach file,$(MAPFILES),vector/$(map)/$(file)))
SRC := $(SRCFILES) $(SQLITEFILES) $(VECTFILES)
SRCDIRS := PERMANENT PERMANENT/vector PERMANENT/sqlite $(patsubst %,PERMANENT/vector/%,$(SQLITEMAPS))

DSTDIR = $(ARCH_DISTDIR)/demolocation
DST := $(patsubst %,$(DSTDIR)/PERMANENT/%,$(SRC))
DSTDIRS := $(patsubst %,$(DSTDIR)/%,$(SRCDIRS))
RCFILE = $(DSTDIR)/.grassrc$(GRASS_VERSION_MAJOR)$(GRASS_VERSION_MINOR)

default: $(DST) $(RCFILE)

$(DSTDIR)/PERMANENT/%: PERMANENT/% | $(DSTDIRS)
	$(INSTALL_DATA) $< $@

$(DSTDIRS): %:
	$(MKDIR) $@

$(RCFILE): grassrc.tmpl | $(DSTDIRS)
	sed 's!@GISDBASE@!$(RUN_GISBASE)!' < $< > $@

=== display/Makefile ===

MODULE_TOPDIR = ..

PGM = displaydrivers

SUBDIRS = \
	d.barscale \
	d.colorlist \
	d.colortable \
	d.erase \
	d.font \
	d.fontlist \
	d.geodesic \
	d.graph \
	d.grid \
	d.his \
	d.histogram \
	d.info \
	d.labels \
	d.legend \
	d.legend.vect \
	d.linegraph \
	d.mon \
	d.northarrow \
	d.path \
	d.profile \
	d.rast \
	d.rast.arrow \
	d.rast.num \
	d.redraw \
	d.rgb \
	d.rhumbline \
	d.text \
	d.title \
	d.vect \
	d.vect.chart \
	d.vect.thematic \
	d.where

include $(MODULE_TOPDIR)/include/Make/Dir.make

default: htmldir

htmldir: parsubdirs

=== general/Makefile ===

MODULE_TOPDIR = ..

SUBDIRS = \
	g.access \
	g.cairocomp \
	g.copy \
	g.dirseps \
	g.filename \
	g.findetc \
	g.findfile \
	g.gisenv \
	g.gui \
	g.list \
	g.mapset \
	g.mapsets \
	g.message \
	g.mkfontcap \
	g.parser \
	g.pnmcomp \
	g.ppmtopng \
	g.proj \
	g.region \
	g.remove \
	g.rename \
	g.tempfile \
	g.version \
	manage

#	g.setproj \

include $(MODULE_TOPDIR)/include/Make/Dir.make

default: parsubdirs

=== gui/Makefile ===
MODULE_TOPDIR = ..

PGM = wxguiintro

SUBDIRS = icons images scripts xml wxpython

include $(MODULE_TOPDIR)/include/Make/Dir.make

default: htmldir

htmldir: parsubdirs

=== imagery/Makefile ===
--- 
+++ 
@@ -30,7 +30,10 @@
 	i.rectify \
 	i.rgb.his \
 	i.segment \
+	i.signatures \
 	i.smap \
+	i.svm.predict \
+	i.svm.train \
 	i.target \
 	i.topo.corr \
 	i.pca \

=== include/Makefile ===
MODULE_TOPDIR = ..

include $(MODULE_TOPDIR)/include/Make/Vars.make
include $(MODULE_TOPDIR)/include/Make/Rules.make

SRCMAKE := $(wildcard ../include/Make/*.make)
DSTMAKE := $(patsubst ../include/Make/%.make,$(ARCH_DISTDIR)/include/Make/%.make,$(SRCMAKE))

default: $(DSTMAKE) parsubdirs

$(ARCH_DISTDIR)/include/Make/%.make: Make/%.make | $(ARCH_DISTDIR)/include/Make
	$(INSTALL_DATA) $< $@

$(ARCH_DISTDIR)/include/Make:
	$(MKDIR) $@

SUBDIRS = \
	grass

include $(MODULE_TOPDIR)/include/Make/Dir.make

=== lib/Makefile ===
MODULE_TOPDIR = ..

include $(MODULE_TOPDIR)/include/Make/Vars.make

#order is relevant:
SUBDIRS = \
	datetime \
	gis \
	proj \
	raster \
	external \
	gmath \
	linkm \
	driver \
	pngdriver \
	psdriver \
	htmldriver \
	cairodriver \
	bitmap \
	btree \
	btree2 \
	display \
	db \
	fonts \
	vector \
	imagery \
	cluster \
	rowio \
	segment \
	rst \
	lidar \
	raster3d \
	raster3d/test \
	gpde \
	dspf \
	symbol \
	init \
	cdhc \
	stats \
	arraystats \
	ogsf \
	nviz \
	temporal \
	iostream \
	manage \
	calc

include $(MODULE_TOPDIR)/include/Make/Dir.make
include $(MODULE_TOPDIR)/include/Make/Doxygen.make

default: subdirs

=== macosx/Makefile ===
MODULE_TOPDIR = ..

include $(MODULE_TOPDIR)/include/Make/Vars.make

SUBDIRS =
ifeq ($(MACOSX_APP),1)
SUBDIRS = app
endif

include $(MODULE_TOPDIR)/include/Make/Dir.make

MACOSX_APP_NAME = GRASS-${GRASS_VERSION_MAJOR}.${GRASS_VERSION_MINOR}.app
MACOSX_APPDIR = ${MACOSX_APP_NAME}/Contents/MacOS
INST_DIR_MACOSX = ${prefix}/${MACOSX_APPDIR}
MACOSX_SUPPDIR = /Library/GRASS/${GRASS_VERSION_MAJOR}.${GRASS_VERSION_MINOR}
MACOSX_BUNDLE_PREFIX = ${GRASS_HOME}/macosx/dist/${MACOSX_APPDIR}
VER_MINOR_REL = `printf "%d0%d" ${GRASS_VERSION_MINOR} ${GRASS_VERSION_RELEASE}`
VER_DATE = `date +"%g%m%d"`
MAKE_DIR_CMD = mkdir -p -m 755
LN = /bin/ln -sf
LN_DIR = /bin/ln -sfh
# get python version - use python in path, should be config'd python
PYVER = `python -V 2>&1 | cut -d \  -f 2 | cut -d . -f 1,2`

# packagemaker location, options and behaviour changed in xcode 3
ifeq ($(findstring darwin8,$(ARCH)),darwin8)
XCODE_VER = xcode2
PACKAGEMAKER = /Developer/Tools/packagemaker
PKG_INST_DIR = ${prefix}/${MACOSX_APP_NAME}
else
XCODE_VER = xcode3
PACKAGEMAKER = /Developer/usr/bin/packagemaker
PKG_INST_DIR = ${prefix}
endif

default: subdirs

include bundle.make

# Duplicated, mostly, from the top-level makefile.

install-macosx: INST_DIR_TARGET = ${INST_DIR}
install-macosx: PREFIX_TARGET = ${prefix}
install-macosx: install-macosxapp install-basic-macosx macosx-support-dir bundle-macosx
	echo ${ARCH_DISTDIR}/${MACOSX_APP_NAME}

# create a packagemaker installer package.
# pretty much the same as install, but needs intermediate install location
# to assemble package parts.

bindist-macosx: INST_DIR_TARGET = ${MACOSX_BUNDLE_PREFIX}
bindist-macosx: PREFIX_TARGET = ${GRASS_HOME}/macosx/dist
bindist-macosx: install-macosxapp install-basic-macosx bundle-macosx
	@# installer pkg resources
	${MAKE_DIR_CMD} dist/resources
	-sed -e "s#@INST_DIR@#${INST_DIR}#g" \
		-e "s#@MACOSX_SUPPDIR@#${MACOSX_SUPPDIR}#g" \
		-e "s#@GRASS_VER@#${GRASS_VERSION_MAJOR}.${GRASS_VERSION_MINOR}#g" \
		-e "s#@PYVER@#${PYVER}#g" \
		pkg/resources/postflight.in > dist/resources/postflight
	-chmod a+rx dist/resources/postflight
	-sed -e "s#@GRASS_VER@#${GRASS_VERSION_MAJOR}.${GRASS_VERSION_MINOR}#g" \
		pkg/resources/Description.plist.in > dist/Description.plist
	-sed -e "s#@GRASS_VERSION_MAJOR@#${GRASS_VERSION_MAJOR}#g" \
		-e "s#@GRASS_VERSION_MINOR@#${GRASS_VERSION_MINOR}#g" \
		-e "s#@GRASS_VERSION_RELEASE@#${GRASS_VERSION_RELEASE}#g" \
		-e "s#@VER_MINOR_REL@#${VER_MINOR_REL}#g" \
		-e "s#@VER_DATE@#${VER_DATE}#g" \
		-e "s#@PKG_INST_DIR@#${PKG_INST_DIR}#g" \
		pkg/resources/Info.plist.in > dist/Info.plist
	-${INSTALL_DATA} pkg/resources/License.rtf dist/resources
	-${INSTALL_DATA} pkg/resources/ReadMe.rtf dist/resources
	@# build the package
ifeq ($(XCODE_VER),xcode3)
	${PACKAGEMAKER} --target 10.4 --root-volume-only --id org.osgeo.grass --root dist/${MACOSX_APP_NAME} --info dist/Info.plist --out "GRASS-${GRASS_VERSION_MAJOR}.${GRASS_VERSION_MINOR}.pkg" --resources dist/resources
	rm -f "GRASS-${GRASS_VERSION_MAJOR}.${GRASS_VERSION_MINOR}.pkg/Contents/Resources/TokenDefinitions.plist"
else
	${PACKAGEMAKER} -build -ds -p "GRASS-${GRASS_VERSION_MAJOR}.${GRASS_VERSION_MINOR}.pkg" -f dist/${MACOSX_APP_NAME} -r dist/resources -i dist/Info.plist -d dist/Description.plist
endif

install-macosxapp:
	-$(MAKE_DIR_CMD) ${INST_DIR_TARGET}/bin
	-$(MAKE_DIR_CMD) ${INST_DIR_TARGET}/etc
	-$(MAKE_DIR_CMD) ${PREFIX_TARGET}/${MACOSX_APP_NAME}/Contents/Resources/Scripts
	-$(MAKE_DIR_CMD) ${PREFIX_TARGET}/${MACOSX_APP_NAME}/Contents/Resources/English.lproj/MainMenu.nib
	$(INSTALL) app/build_html_user_index.sh ${INST_DIR_TARGET}/etc
	$(INSTALL) app/build_gui_user_menu.sh ${INST_DIR_TARGET}/etc
	$(INSTALL) app/python_wrapper ${INST_DIR_TARGET}/bin/python
	$(INSTALL_DATA) app/AppIcon.icns ${PREFIX_TARGET}/${MACOSX_APP_NAME}/Contents/Resources
	$(INSTALL_DATA) app/GRASSDocument_gxw.icns ${PREFIX_TARGET}/${MACOSX_APP_NAME}/Contents/Resources
	$(INSTALL_DATA) app/${OBJDIR}/Info.plist ${PREFIX_TARGET}/${MACOSX_APP_NAME}/Contents
	$(INSTALL_DATA) app/PkgInfo ${PREFIX_TARGET}/${MACOSX_APP_NAME}/Contents
	$(INSTALL) app/${OBJDIR}/GRASS.scpt ${PREFIX_TARGET}/${MACOSX_APP_NAME}/Contents/Resources/Scripts/
	$(INSTALL) app/${OBJDIR}/grass.sh ${INST_DIR_TARGET}
	$(INSTALL) app/${OBJDIR}/GRASS ${INST_DIR_TARGET}
	$(INSTALL_DATA) app/English.lproj/MainMenu.nib/* ${PREFIX_TARGET}/${MACOSX_APP_NAME}/Contents/Resources/English.lproj/MainMenu.nib

install-basic-macosx:
	-tar cBCf $(GISBASE) - . | tar xBCf $(INST_DIR_TARGET) - 2>/dev/null
	-sed -e 's#'$(GISBASE)'#'$(INST_DIR)'#g' \
		${GISBASE}/etc/fontcap > ${INST_DIR_TARGET}/etc/fontcap
	-sed -e 's#'$(GISBASE)'#'$(INST_DIR)'#g' \
		${GISBASE}/demolocation/.grassrc$(GRASS_VERSION_MAJOR)$(GRASS_VERSION_MINOR) > ${INST_DIR_TARGET}/demolocation/.grassrc$(GRASS_VERSION_MAJOR)$(GRASS_VERSION_MINOR)
	sed -e 's#^\(GRASS_HOME.[^=]*\).*#\1= $(INST_DIR)#g' \
		-e 's#$(GISBASE)#$(INST_DIR)#g' \
		-e "s#-isysroot /.*MacOSX.*\.sdk##g" \
		${GISBASE}/include/Make/Platform.make > ${INST_DIR_TARGET}/include/Make/Platform.make
	sed -e 's#^\(ARCH_DISTDIR.[^=]*\).*#\1= $(INST_DIR)#g' \
		-e 's#^\(ARCH_BINDIR.[^=]*\).*#\1= $(UNIX_BIN)#g' \
		${GISBASE}/include/Make/Grass.make > ${INST_DIR_TARGET}/include/Make/Grass.make
	-sed -e 's#'@GISBASE@'#'$(INST_DIR)'#g' \
	     -e 's#'@LD_LIBRARY_PATH_VAR@'#'$(LD_LIBRARY_PATH_VAR)'#g' \
	     -e 's#'@CONFIG_PROJSHARE@'#'$(PROJSHARE)'#g' \
	     $(ARCH_DISTDIR)/$(GRASS_NAME).tmp > $(INST_DIR_TARGET)/$(GRASS_NAME)
	-chmod a+x $(INST_DIR_TARGET)/$(GRASS_NAME)
	-rm -f $(INST_DIR_TARGET)/$(GRASS_NAME).tmp
	-chmod -R a+rX ${PREFIX_TARGET}/${MACOSX_APP_NAME} 2>/dev/null
	-touch ${PREFIX_TARGET}/${MACOSX_APP_NAME}

macosx-support-dir:
	${MAKE_DIR_CMD} "${MACOSX_SUPPDIR}"
	${MAKE_DIR_CMD} "${MACOSX_SUPPDIR}/Modules/bin"
	${MAKE_DIR_CMD} "${MACOSX_SUPPDIR}/Modules/docs/html"
	${MAKE_DIR_CMD} "${MACOSX_SUPPDIR}/Modules/etc"
	${MAKE_DIR_CMD} "${MACOSX_SUPPDIR}/Modules/lib"

=== misc/Makefile ===
MODULE_TOPDIR = ..

SUBDIRS = \
	m.cogo \
	m.measure \
	m.nviz.image \
	m.nviz.script \
	m.transform

include $(MODULE_TOPDIR)/include/Make/Dir.make

default: parsubdirs

=== debian/changelog ===
grass (8.4.1-1build1) resolute; urgency=medium

  * No-change rebuild for libgdal37.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 30 Oct 2025 20:49:37 +0000

grass (8.4.1-1) unstable; urgency=medium

  * New upstream release.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 24 Feb 2025 18:10:20 +0100

grass (8.4.1~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Drop python3-six (build) dependency.
    (closes: #1039455)
  * Drop fakeroot (build) dependency.
    (closes: #1079613)
  * Update watch file to use download.osgeo.org.
  * Update copyright file.
  * Refresh patches.
  * Drop rules for CHANGES file removed upstream.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 12 Feb 2025 05:39:59 +0100

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,6 @@
                dh-sequence-numpy3,
                dh-sequence-python3,
                doxygen,
-               fakeroot,
                flex,
                graphviz,
                libblas-dev,
@@ -47,7 +46,6 @@
                python3-numpy,
                python3-pil,
                python3-ply,
-               python3-six,
                python3-wxgtk4.0,
                unixodbc-dev,
                zlib1g-dev
@@ -78,7 +76,6 @@
 Package: grass-core
 Architecture: any
 Depends: grass-doc,
-         python3-six,
          ${shlibs:Depends},
          ${python3:Depends},
          ${misc:Depends}
@@ -180,8 +177,6 @@
 Section: devel
 Architecture: any
 Depends: grass-core (= ${binary:Version}),
-# fakeroot used by patches/htmlgen-fakeroot; see changelog entry for 5.7.0+6.0.0beta2-2
-         fakeroot,
          libfreetype-dev,
          libgdal-dev,
          libpq-dev,

=== debian/rules ===
--- 
+++ 
@@ -169,7 +169,6 @@
 
 	# Remove files not installed or installed by debhelper
 	$(RM) -r debian/tmp/usr/lib/$(BASE_NAME)/AUTHORS \
-	         debian/tmp/usr/lib/$(BASE_NAME)/CHANGES \
 	         debian/tmp/usr/lib/$(BASE_NAME)/CITING \
 	         debian/tmp/usr/lib/$(BASE_NAME)/COPYING \
 	         debian/tmp/usr/lib/$(BASE_NAME)/GPL.TXT \
@@ -211,9 +210,6 @@
 		rm -rf debian/$(PKG_NAME)-core/usr/lib/$(BASE_NAME)/$$COMPONENT; \
 	done
 
-override_dh_installchangelogs:
-	dh_installchangelogs CHANGES
-
 override_dh_python3:
 	dh_python3 -pgrass-core -pgrass-gui -pgrass-dev
 	dh_python3 -pgrass-core /usr/lib/$(BASE_NAME)/etc/
@@ -233,3 +229,7 @@
 override_dh_fixperms:
 	dh_fixperms -Xr.in.png -Xr.out.png
 
+override_dh_gencontrol:
+	dh_gencontrol -- -Vgrass:Provides="$(GRASS_ABI)"
+
+.PHONY: templates versions

=== debian/watch ===
version=4
opts=\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/;s/RC/rc/;s/_/./g,\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$// \
https://download.osgeo.org/grass/grass(\d+)/source/ \
grass-([\d\._]*(?:(?:RC|rc|pre|dev|beta|alpha)?\d*))\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
